
#ifndef REDISPROVIDERCONFIGURATOR_H_
#define REDISPROVIDERCONFIGURATOR_H_

#include <Base_Configurator.h>
#include <Redis_Provider.h>

namespace inaf::oasbo::Providers {

class RedisProviderConfigurator : public BaseConfigurator{

public:
	RedisProviderConfigurator(int argc, char **argv);
	RedisProviderConfigurator();

	void setRedisIP(std::string val){this->params["redisIP"] = val;}
	void setRedisPort(int val){this->params["redisPort"] = std::to_string(val);}
	void setRedisKey(std::string val){this->params["redisKey"] = val;}


	std::map<std::string,std::string> getParams(){return this->params;}
	std::string getRedisIP(){return this->params["redisIP"];}
	int getRedisPort(){return stoi(this->params["redisPort"]);}
	std::string getRedisKey(){return this->params["redisKey"];}

	BaseProvider * createProvider();
	RedisProvider * createRedisProvider();
	void createRedisProvider(RedisProvider &);



	void printConfiguration(){
		std::string confStr = "Redis Provider Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}

};
}
#endif
